【HDU 4276】The Ghost Blows Light(树形DP,依赖背包)

The Ghost Blows Light

 

Problem Description

My name is Hu Bayi, robing an ancient tomb in Tibet. The tomb consists of N rooms (numbered from 1 to N) which are connected by some roads (pass each road should cost some time). There is exactly one route between any two rooms, and each room contains some treasures. Now I am located at the 1st room and the exit is located at the Nth room. 
Suddenly, alert occurred! The tomb will topple down in T minutes, and I should reach exit room in T minutes. Human beings die in pursuit of wealth, and birds die in pursuit of food! Although it is life-threatening time, I also want to get treasure out as much as possible. Now I wonder the maximum number of treasures I can take out in T minutes.
 

 

Input
There are multiple test cases.
The first line contains two integer N and T. (1 <= n <= 100, 0 <= T <= 500)
Each of the next N - 1 lines contains three integers a, b, and t indicating there is a road between a and b which costs t minutes. (1<=a<=n, 1<=b<=n, a!=b, 0 <= t <= 100)
The last line contains N integers, which Ai indicating the number of treasure in the ith room. (0 <= Ai <= 100)
 

 

Output
For each test case, output an integer indicating the maximum number of treasures I can take out in T minutes; if I cannot get out of the tomb, please output "Human beings die in pursuit of wealth, and birds die in pursuit of food!".
 

 

Sample Input
5 10 1 2 2 2 3 2 2 5 3 3 4 3 1 2 3 4 5
 

 

Sample Output
11
 

 

Source
 

 

 

【题意】

  一个有 N 个节点的树形的地图,知道了每条边经过所需要的时间,现在给出时间T,问能不能在T时间内从 1号节点到 N 节点。每个节点都有相对应的价值,而且每个价值只能被取一次,问如果可以从1 号节点走到 n 号节点的话,最多可以取到的最大价值为多少。

 

【分析】

  这题跟poj2486类似,不过这题的问题是不知道是否回到n。
  规定回到n的话,我们画一下图会发现,我们走的路径是1到n的路径只走一遍,其他路径一定是去和回的两遍。所以我们可以先求出1~n的路径,然后把这些边权置为0,然后就是依赖背包问题,f[i][j]表示在i这棵子树上走j分钟的最大价值,我们走一条边的费用是*2的,因去和回是两遍,最后要加上1~n的路径的代价。
  (网上打的都是树形0-1背包是n^3,依赖背包可以打成n^2)

 

代码如下:

 1 #include<cstdio>
 2 #include<cstdlib>
 3 #include<cstring>
 4 #include<iostream>
 5 #include<algorithm>
 6 using namespace std;
 7 #define Maxn 110
 8 #define Maxm 510
 9 
10 struct node
11 {
12     int x,y,c,next;
13 }t[Maxn*2];int len;
14 int first[Maxn],w[Maxn];
15 
16 int mymax(int x,int y) {return x>y?x:y;}
17 
18 void ins(int x,int y,int c)
19 {
20     t[++len].x=x;t[len].y=y;t[len].c=c;
21     t[len].next=first[x];first[x]=len;
22 }
23 
24 int n,v;
25 int dis[Maxn],sum;
26 
27 bool dfs(int x,int fa)
28 {
29     if(x==n) return 1;
30     for(int i=first[x];i;i=t[i].next) if(t[i].y!=fa)
31     {
32         int y=t[i].y;
33         dis[y]=dis[x]+t[i].c;
34         if(dfs(y,x)) {sum+=t[i].c;t[i].c=0;return 1;}
35     }
36     return 0;
37 }
38 
39 int f[Maxn][Maxm];
40 void ffind(int x,int fa)
41 {
42     for(int i=first[x];i;i=t[i].next) if(t[i].y!=fa)
43     {
44         int y=t[i].y;
45         for(int j=0;j<=v-2*t[i].c;j++) if(f[x][j]!=-1)
46         {
47             f[y][j+2*t[i].c]=mymax(f[y][j+2*t[i].c],f[x][j])+w[y];
48         }
49         ffind(y,x);
50         for(int j=0;j<=v;j++) if(f[y][j]!=-1)
51         {
52             f[x][j]=mymax(f[x][j],f[y][j]);
53         }
54     }
55 }
56 
57 int main()
58 {
59     while(scanf("%d%d",&n,&v)!=EOF)
60     {
61         len=0;
62         memset(first,0,sizeof(first));
63         for(int i=1;i<n;i++)
64         {
65             int x,y,c;
66             scanf("%d%d%d",&x,&y,&c);
67             ins(x,y,c);ins(y,x,c);
68         }
69         for(int i=1;i<=n;i++) scanf("%d",&w[i]);
70         sum=0;
71         dfs(1,0);
72         if(sum>v)
73         {
74             printf("Human beings die in pursuit of wealth, and birds die in pursuit of food!\n");
75         }
76         else
77         {
78             memset(f,-1,sizeof(f));
79             f[1][0]=w[1];
80             ffind(1,0);
81             int ans=0;
82             for(int i=0;i<=v-sum;i++) ans=mymax(ans,f[1][i]);
83             printf("%d\n",ans);
84         }
85         
86     }
87     return 0;
88 }
[HDU 4276]

 

2016-10-18 10:51:20

posted @ 2016-10-18 10:46  konjak魔芋  阅读(277)  评论(0编辑  收藏  举报